#ifndef __TEXTUREPOOL_H
#define __TEXTUREPOOL_H
/*
eNX`̊ǗNX

Eǂݍ݉\ȃeNX`̉摜`bmpCtgaCjpegCpng

	
	jpeg̓ǂݍ݂ɂJPEGCuilibjpeg.lib, jpeglib.hjʓrKv
	jpeg̓ǂݍ݂Lɂɂ́C̃wb_ DEF_USE_LIBJPEG  1 ɂ邱

	png̓ǂݍ݂ɂPNGCuilibpng.lib, zlib.lib, png.h ,zlib.hjʓrKv
	png̓ǂݍ݂Lɂɂ́C̃wb_ DEF_USE_LIBPNG   1 ɂ邱

EeNX`摜̃TCÝuӂ2nTCY(64,128,256c)̐`vɌ

EeNX`̃TCY͏ĉɂΉĂ܂B

Erbg}bvAsf`t@C͉f̊i[
@EBB̏ɂΉĂ܂B

Esf`t@C̓gGfBAŊi[Ă̂ƂďĂ܂B

ӁfXgN^œo^eNX`Ă܂B
@@@eNX`gpɂ̃NXȂłB

gp@
PjRXgN^̒g̓JłBeLg[ɃNX쐬
Qjset\bhœo^eNX`̃t@Cw
Rjset\bh̖߂lnfk֓o^ꂽԍȂ̂
@@\gpăeNX`gB
j
texturePool pool ;
GLuint texName ;
texName = pool.set("eNX`.bmp","x.tga") ;
glBindTexture(GL_TEXTURE_2D,texName) ;

code by kei
*/
#define DEF_USE_LIBJPEG			0			// libjpeg̎gpiPgp@Ogpj
#define DEF_USE_LIBPNG			0			// libpng ̎gpiPgp@Ogpj

#ifdef WIN32
	#include <windows.h>
#else
	#ifndef MAX_PATH
		#define MAX_PATH    256
	#endif
	#ifndef TRUE
		#define TRUE    (1==1)
	#endif
	#ifndef FALSE
	    #define FALSE   (1!=1)
	#endif
#endif
#include <stdio.h>
#include <vector>
#ifdef __APPLE__
	#include <OpenGL/gl.h>
#else
	#include <GL/gl.h>
#endif
#include "endianConverter.h"

// JPEGgp
#ifdef D_JPEG
	#undef	DEF_USE_LIBJPEG
	#define	DEF_USE_LIBJPEG 1
#endif

// JPEGgpȂ
#ifdef D_NO_JPEG
	#undef	DEF_USE_LIBJPEG
	#define	DEF_USE_LIBJPEG 0
#endif

// PNGgp
#ifdef D_PNG
	#undef	DEF_USE_LIBPNG
	#define	DEF_USE_LIBPNG 1
#endif

// PNGgpȂ
#ifdef D_NO_PNG
	#undef	DEF_USE_LIBPNG
	#define	DEF_USE_LIBPNG 0
#endif

#if DEF_USE_LIBJPEG

	#define XMD_H // INT16INT32̍Ē`G[h
	#ifdef FAR
		#undef FAR
	#endif

	#ifdef __cplusplus
	extern "C" {
	#endif
	#include "jpeglib.h"
	#ifdef __cplusplus
	}
	#endif
	#pragma comment(lib,"libjpeg.lib")

#endif
#if DEF_USE_LIBPNG

	#include "png.h"
	#include "zlib.h"
	#pragma comment(lib,"libpng.lib")
	#pragma comment(lib,"zlib.lib")

#endif


using namespace std ;
class texturePool
{
public :
	//TGAt@C^Cv
	enum ENUM_TGA_TYPE {
		NON = 0,
		INDEX,
		FULL,
		MONO,

		RLEINDEX = 9,
		RLEFULL,
		RLEMONO
	}  ;
private :
	typedef struct {
		unsigned char	id;
		unsigned char	color_map_flag;
		unsigned char	type;
		unsigned short	color_map_entry;
		unsigned char	color_map_entry_size;
		unsigned short	x;
		unsigned short	y;
		unsigned short	width;
		unsigned short	height;
		unsigned char	depth;
		unsigned char	bit_info;
	} STR_TGA_HEAD;//sf`t@Cwb_̍\

	typedef struct {
		GLuint			texture_id;			// eNX`ID
		int				texsize;			// eNX`TCY
		char			texfile[MAX_PATH];	// eNX`t@C
		char			alpfile[MAX_PATH];	// At@eNX`t@C
	} TEXTURE_POOL;//eNX`v[pf[^
	vector<TEXTURE_POOL> m_pool ;//eNX`ۑRei
public :
	GLuint get(int num) {
		return m_pool[num].texture_id ;
	}
	//RXgN^
	texturePool() {
	}
	//fXgN^
	//	œo^eNX`ĂB
	virtual ~texturePool() {
		int pos;
		int max = (int)m_pool.size() ;

		for ( pos = 0; pos < max; pos++ ) {
			glDeleteTextures(1,&m_pool[pos].texture_id) ;
		}
		m_pool.clear() ;
	}

	//eNX`o^
	// in texfile	eNX`t@C
	// in alpfile	xt@CiomfAsf`̂݁j
	//@߂l@GLuint OpenGLɓo^eNX`ԍ
	GLuint set(char *texfile,char *alpfile=NULL) {
		int pos;
		GLubyte *image;
		int max = (int)m_pool.size() ;

		for ( pos = 0; pos < max; pos++ ) {
			if ( texfile != NULL ) {
				if ( strcmp(texfile,m_pool[pos].texfile) != 0 ) {
					continue;
				}
			}
			if ( alpfile != NULL ) {
				if ( strcmp(alpfile,m_pool[pos].alpfile) != 0 ) {
					continue;
				}
			}
			break;
		}
		if ( pos < max ) { //łɓǂݍݍς
			return  m_pool[pos].texture_id;
		}
		TEXTURE_POOL pooldata ;
		memset(&pooldata,0,sizeof(pooldata)) ;
		image = loadTexture(texfile,alpfile,&pooldata.texsize);
		if ( image == NULL ) {
			return 0;
		}
		if ( texfile != NULL ) strncpy(pooldata.texfile,texfile,MAX_PATH);
		if ( alpfile != NULL ) strncpy(pooldata.alpfile,alpfile,MAX_PATH);

		glPixelStorei(GL_UNPACK_ALIGNMENT,1);
		glPixelStorei(GL_PACK_ALIGNMENT,1);
		glGenTextures(1,&pooldata.texture_id);			// eNX`𐶐
		int bindtex ;
		glGetIntegerv(GL_TEXTURE_BINDING_2D,&bindtex) ;		// ݂̃eNX`ۑ
		glBindTexture(GL_TEXTURE_2D,pooldata.texture_id);	// eNX`̊蓖

		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA8, pooldata.texsize, pooldata.texsize,
						0, GL_RGBA, GL_UNSIGNED_BYTE, image);

		//o^΁Aǂݍ񂾃obt@͕sv
		free(image);

		m_pool.push_back(pooldata) ;

		glBindTexture(GL_TEXTURE_2D,bindtex);	//̃eNX`̊蓖
		return pooldata.texture_id ;
	}
private :
	//t@Cǂݍݏ
	// in  texfile	eNX`t@C
	// in  alpfile	xt@CiomfAsf`̂݁j
	// out ǂݍ񂾃eNX`̃TCYict@CɂΉĂȂj
	//@߂l@ǂݍ񂾃C[Wf[^
	GLubyte* loadTexture(char *texfile,char *alpfile,int *tex_size)
	{
		FILE *fp;
		size_t namelen;
		char ext[4];
		char wbuf[3];
		int isTGA;
		int isPNG;
		int isJPEG;
		int other;
		int	y,x,size;
		int fl;
		char *filename[2];
		int width[2];
		int sts;
		STR_TGA_HEAD tgah;
		GLubyte	*pImage, *pRead;

#if DEF_USE_LIBJPEG
		struct jpeg_decompress_struct cinfo;
		struct jpeg_error_mgr jerr;
		JSAMPARRAY jpegimage;
#endif
#if DEF_USE_LIBPNG
		unsigned char **pngimage;
		unsigned long   pngwidth, pngheight;
		int				pngdepth;
		int             color_type;
#endif

		filename[0] = texfile;
		filename[1] = alpfile;
		width[0] = -1;
		width[1] = -1;
		pImage = NULL;
		fp = NULL;
		sts = 0;
#if DEF_USE_LIBJPEG
		jpegimage = NULL;
#endif
#if DEF_USE_LIBPNG
		pngimage = NULL;
#endif
		size = - 1;
		for ( fl = 0; fl < 2; fl++ ) {//eNX`fl=0    At@fl=1
			if ( filename[fl] == NULL ) continue;
			namelen = strlen(filename[fl]);
			ext[0] = tolower(filename[fl][namelen-3]);
			ext[1] = tolower(filename[fl][namelen-2]);
			ext[2] = tolower(filename[fl][namelen-1]);
			ext[3] = 0x00;
			isTGA = (strcmp(ext,"tga")==0)?1:0;
			isPNG = (strcmp(ext,"png")==0)?1:0;
			isJPEG = (strcmp(ext,"jpg")==0)?1:0;
			/* */
			if ( (! isTGA) && (! isPNG) &&(! isJPEG) ) {
				filename[fl][namelen-3] = 'b';
				filename[fl][namelen-2] = 'm';
				filename[fl][namelen-1] = 'p';
			}
			/* */
			if ( fl == 1 ) { //At@̓ǂݍ݂͂sf`oromf
				if ( ! (isTGA || isPNG) ) {
					printf("At@̃t@CɑΉłȂ%s\n",filename[fl]);
					break;
				}
			}
			if ( fp != NULL ) fclose(fp);
			if ( (fp=fopen(filename[fl],"rb"))==NULL ) {
				printf("%s:eNX`ǂݍ݃G[[%s]\n",__FILE__,filename[fl]);
				continue;
			}
			// wb_̃[h
			if ( isTGA ) {
				fread(&tgah,sizeof(STR_TGA_HEAD),1,fp);
#if DEF_IS_LITTLE_ENDIAN
#else
				TGAHeaderEndianConverter(&tgah);
#endif
				size = width[fl] = tgah.width;
			}
			if ( isJPEG ) {
#if DEF_USE_LIBJPEG
				unsigned int i;
				cinfo.err = jpeg_std_error( &jerr );
				jpeg_create_decompress( &cinfo );	//𓀗p쐬
				jpeg_stdio_src( &cinfo, fp );		//ǂݍ݃t@Cw
				jpeg_read_header( &cinfo, TRUE );	//jpegwb_ǂݍ
				jpeg_start_decompress( &cinfo );	//𓀊Jn

				if ( cinfo.out_color_components == 3 && cinfo.out_color_space == JCS_RGB ) {
					if ( jpegimage != NULL ) {
						for (i = 0; i < cinfo.output_height; i++) free(jpegimage[i]);            // ȉQs͂Qz܂
						free(jpegimage);
					}
					//ǂݍ݃f[^z̍쐬
					jpegimage = (JSAMPARRAY)malloc( sizeof( JSAMPROW ) * cinfo.output_height );
					for ( i = 0; i < cinfo.output_height; i++ ) {
						jpegimage[i] = (JSAMPROW)malloc( sizeof( JSAMPLE ) * cinfo.out_color_components * cinfo.output_width );
					}
					//𓀃f[^ǂݍ
					while( cinfo.output_scanline < cinfo.output_height ) {
						jpeg_read_scanlines( &cinfo,
							jpegimage + cinfo.output_scanline,
							cinfo.output_height - cinfo.output_scanline
						);
					}
					size = width[fl] = cinfo.output_width;
				}

				jpeg_finish_decompress( &cinfo );	//𓀏I
				jpeg_destroy_decompress( &cinfo );	//𓀗p
				if ( !(cinfo.out_color_components == 3 && cinfo.out_color_space == JCS_RGB) ) {
					printf("JPEG ΉłȂtH[}bg%s\n",filename[fl]);
				}
#else
				printf("̃eNX`͑ΉłȂtH[}bg%s\n",filename[fl]);
				continue;
#endif
			}
			if ( isPNG ) {
#if DEF_USE_LIBPNG
				png_structp     png_ptr;
				png_infop       info_ptr;
				int             bit_depth, interlace_type;
				unsigned int             i;
				int j,k;
				png_ptr = png_create_read_struct(                       // png_ptr\̂mہE܂
								PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
				info_ptr = png_create_info_struct(png_ptr);             // info_ptr\̂mہE܂
				png_init_io(png_ptr, fp);                               // libpngfpm点܂
				png_read_info(png_ptr, info_ptr);                       // PNGt@C̃wb_ǂݍ݂܂
				png_get_IHDR(png_ptr, info_ptr, &pngwidth, &pngheight,        // IHDR`N擾܂
								&bit_depth, &color_type, &interlace_type,
								&j,&k);
				if ( pngimage != NULL ) {
					for (i = 0; i < pngheight; i++) free(pngimage[i]);            // ȉQs͂Qz܂
					free(pngimage);
				}
				pngimage = (png_bytepp)malloc(pngheight * sizeof(png_bytep)); // ȉRs͂Qzmۂ܂
				i = png_get_rowbytes(png_ptr, info_ptr);
				pngdepth = i / pngwidth;
				for (i = 0; i < pngheight; i++)
						pngimage[i] = (png_bytep)malloc(png_get_rowbytes(png_ptr, info_ptr));
				png_read_image(png_ptr, pngimage);                         // 摜f[^ǂݍ݂܂

				png_destroy_read_struct(                                // Q̍\̂̃܂
				&png_ptr, &info_ptr, (png_infopp)NULL);
				size = width[fl] = pngwidth;
#else
				printf("̃eNX`͑ΉłȂtH[}bg%s\n",filename[fl]);
				continue;
#endif
			}
			if ( width[fl] == -1 ) {//RR܂łăTCYw肳ĂȂ@@rbg}bv
				fseek(fp,14+4,SEEK_SET);		// 摜i[Ăʒu܂ŃV[N
				fread(&size,sizeof(int),1,fp);	// BiWidth̏񂾂擾
				fseek(fp,14+40,SEEK_SET);		// ff[^i[Ăʒu܂ŃV[N
#if DEF_IS_LITTLE_ENDIAN
#else
				endianConverter(&size,sizeof(int));
#endif
				width[fl] = size;

			}
			if ( width[0] != -1 && width[1] != -1 ) {
				if ( width[0] != width[1] ) {
					sts = -1;
					break;
				}
			}
			if ( fl == 1 && isTGA ) { //At@̓ǂݍ݂͂sf`̂WrbgmNRQrbgt
				if ( !(
					(tgah.depth == 8 && tgah.type == ENUM_TGA_TYPE::MONO) ||
					(tgah.depth == 32 && tgah.type == ENUM_TGA_TYPE::FULL) 
					) ) {
					break;
				}
			}
			if ( fl == 1 && isPNG ) { //At@̓ǂݍ݂͂omf̃gD[J[{At@O[XP[{At@
#if DEF_USE_LIBPNG
				if ( !(
					(color_type== 6 ) ||
					(color_type== 4 ) 
					) ) {
					break;
				}
#endif
			}

			// ̊m
			if ( pImage == NULL ) {
				pImage = (GLubyte*)malloc(sizeof(unsigned char)*size*size*4);
			}
			if (pImage==NULL) return NULL;
			for (y=0; y<size; y++){
				pRead = pImage + (size-1-y)*4*size;
				for (x=0; x<size; x++) {
					other = 1;
					if ( fl == 0 ) {
						if ( isJPEG ) {
#if DEF_USE_LIBJPEG
							pRead[0]= jpegimage[size-1-y][x*3];
							pRead[1]= jpegimage[size-1-y][x*3+1];
							pRead[2]= jpegimage[size-1-y][x*3+2];
							pRead[3] = 0xff;				// A
							other = 0;
#endif
						}
						if ( isPNG ) {
#if DEF_USE_LIBPNG
							if ( color_type == 2 || color_type==6 ) { 
								pRead[0]= pngimage[size-1-y][x*pngdepth];
								pRead[1]= pngimage[size-1-y][x*pngdepth+1];
								pRead[2]= pngimage[size-1-y][x*pngdepth+2];
								pRead[3] = 0xff;				// A
								if ( color_type == 6 ) {
									pRead[3]= pngimage[size-1-y][x*pngdepth+3];
								}
							}
							other = 0;
#endif
						}
						if ( other )  {
							fread(&pRead[2],1,1,fp);	// B
							fread(&pRead[1],1,1,fp);	// G	
							fread(&pRead[0],1,1,fp);	// R
							pRead[3] = 0xff;				// A
							if ( isTGA && tgah.depth == 32 ) {
								fread(&pRead[3],1,1,fp);	// A
							}
						}
					}
					else {
						if ( isPNG ) {
#if DEF_USE_LIBPNG
							if ( color_type == 6 ) { //gD[J[{At@
								pRead[3]= pngimage[size-1-y][x*pngdepth+3];
							}
							if ( color_type == 4 ) { //O[XP[{At@
								pRead[3]= pngimage[size-1-y][x*pngdepth+1];
							}
#endif
						}
						if ( isTGA ) {
							if ( tgah.depth == 32 ) { //Ȃf[^ǂݔ΂
								fread(wbuf,3,1,fp);	// BGR
							}
							fread(&pRead[3],1,1,fp);	// A
						}
					}
					pRead+=4;
				}
			}
			fclose(fp);
			fp = NULL;
		}
		if ( sts != 0 ) {
			if ( pImage != NULL ) free(pImage);
			if ( fp != NULL ) fclose(fp);
		}
#if DEF_USE_LIBPNG
		if ( pngimage != NULL ) {
			unsigned int uy;
			for (uy = 0; uy < pngheight; uy++) free(pngimage[uy]);            // ȉQs͂Qz܂
			free(pngimage);
		}
#endif
#if DEF_USE_LIBJPEG
		if ( jpegimage != NULL ) {
			unsigned int uy;
			for (uy = 0; uy < cinfo.output_height; uy++) free(jpegimage[uy]);            // ȉQs͂Qz܂
			free(jpegimage);
		}
#endif
		if ( size < 0 ) {
			if ( pImage != NULL ) free(pImage);
			pImage = NULL;
		}
		*tex_size = size;

		return pImage;
	}
	//sf`t@Cwb_̃GfBAϊ
	void TGAHeaderEndianConverter(	STR_TGA_HEAD *tgah )
	{
		endianConverter(&tgah->color_map_entry,sizeof(tgah->color_map_entry));
		endianConverter(&tgah->x,sizeof(tgah->x));
		endianConverter(&tgah->y,sizeof(tgah->y));
		endianConverter(&tgah->width,sizeof(tgah->width));
		endianConverter(&tgah->height,sizeof(tgah->height));
	}

};



#endif