#ifndef __CGLMETASEQ_H
#define __CGLMETASEQ_H
/*
^ZRt@Ci*.mqoj\NX
@ǂݍ݂cGLMetaseqParentNXłB

EŒ̋@\ĂȂłB

gp@
E
PjcGLMetaseqParentNX쐬iARToolKit̏ꍇCargInit()̌Ɏgpj
QjcGLMetaseqParent::makeGLMetaseq\bhgcGLMetaseqNX쐬

E`@
PjcGLMetaseq::render\bhĂяoΕ`悳܂B

ǂݍ񂾃^ZRt@C̍őlAŏl͈ȉ̕@Ŏo܂B
	const GLfloat *min = (cGLMetaseqNX).getMinPoint() ;
	const GLfloat *max = (cGLMetaseqNX).getMaxPoint() ;
	min(max)[0]=x@[1]=y  [2]=z

gpFARToolKitɂă^ZRt@C̑}[J_ɒuꍇ
	const GLfloat *min = (cGLMetaseqNX).getMinPoint() ;
	glTranslatef(0,0,min[2]*(-1)) ;
	(cGLMetaseqNX).render() ;



^ZRtH[}bg͂B
http://www.metaseq.net/metaseq/format.html

code by kei

*/
#ifdef _WIN32
#include <windows.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#ifndef __APPLE__
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#else
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#include <GLUT/glut.h>
#endif
#include "texturePool.h"
#include "endianConverter.h"
#include "WinGlExtensions.h"
#include <vector>


class cGLMetaseq
{
private :
	friend class cGLMetaseqParent;
	//\p
	typedef struct {		
		GLfloat point[3];	// _z (x, y, z)
		GLfloat normal[3];	// @z (x, y, z)
		GLfloat uv[2];		// UVz (u, v)
	} VERTEX_TEXUSE;
	typedef struct {
		GLfloat point[3];	// _z (x, y, z)
		GLfloat normal[3];	// @z (x, y, z)
	} VERTEX_NOTEX;
	typedef struct {
		bool			isValidMaterialInfo;// }eA̗L/
		bool			isUseTexture;		// eNX`̗LFUSE_TEXTURE / NOUSE_TEXTURE
		GLuint			texture_id;			// eNX`̖O(OpenGL)
		GLuint			VBO_id;				// _obt@ID(OpenGL)@ΉĂ鎞gp
		int				datanum;			// _
		GLfloat			color[4];			// Fz (r, g, b, a)
		GLfloat			dif[4];				// gU
		GLfloat			amb[4];				// ͌
		GLfloat			emi[4];				// ȏƖ
		GLfloat			spc[4];				// ˌ
		GLfloat			power;				// ˌ̋
		VERTEX_NOTEX	*vertex_p;			// |Ŝ݂̎̒_z
		VERTEX_TEXUSE	*vertex_t;			// eNX`gp̒_z
	} MQO_MATERIAL;
	typedef struct {
		char			objname[256];		// IuWFNgidlɕ̋KȂj
		bool			isVisible;			// 0F\@̑F\
		bool			isShadingFlat ;		// VF[fBO[h
		GLfloat minPoint[3];	// _ (x, y, z)
		GLfloat maxPoint[3];	// _ (x, y, z)
		vector<MQO_MATERIAL>	mat;		// }eAz
	} MQO_INNER_OBJECT;
	typedef struct {
		unsigned char		alpha;				// _z쐬Ɏw肳ꂽAt@liQƗpj
		GLfloat minPoint[3];	// _ (x, y, z)
		GLfloat maxPoint[3];	// _ (x, y, z)
		vector<MQO_INNER_OBJECT *>	obj;		// IuWFNgz
	} MQO_OBJECT;
	typedef struct {
		GLfloat minPoint[3];	// _ (x, y, z)
		GLfloat maxPoint[3];	// _ (x, y, z)
		vector<MQO_OBJECT *>	model;		// f
	} MQO_SEQUENCE;

	MQO_SEQUENCE m_seq ;
	cGLMetaseq(MQO_OBJECT *data) {
		m_seq.minPoint[0] = data->minPoint[0] ;
		m_seq.minPoint[1] = data->minPoint[1] ;
		m_seq.minPoint[2] = data->minPoint[2] ;
		m_seq.maxPoint[0] = data->maxPoint[0] ;
		m_seq.maxPoint[1] = data->maxPoint[1] ;
		m_seq.maxPoint[2] = data->maxPoint[2] ;
		m_seq.model.push_back(data) ;
	}
	void push_back(MQO_OBJECT *data) {
		for( int xyz = 0 ; xyz < 3 ; xyz++ ) {
			if( data->minPoint[xyz] < m_seq.minPoint[xyz] ) 
				m_seq.minPoint[xyz] = data->minPoint[xyz] ;
			if( m_seq.maxPoint[xyz] < data->maxPoint[xyz] ) 
				m_seq.maxPoint[xyz] = data->maxPoint[xyz] ;
		}
		m_seq.model.push_back(data) ;
	}
public :
	virtual ~cGLMetaseq() {
		size_t s,s_num ;
		size_t i,i_num ;
		size_t m,m_num ;
		MQO_OBJECT *obj ;
		MQO_INNER_OBJECT *inner ;
		vector<MQO_INNER_OBJECT *>::iterator inner_it ;
		vector<MQO_OBJECT *>::iterator obj_it ;
		s_num = m_seq.model.size() ;
		for( s = 0 ; s < s_num ; s++ ) {
			obj = m_seq.model.at(s) ;
			i_num = obj->obj.size() ;
			for( i = 0 ; i < i_num ; i++ ) {
				inner = obj->obj.at(i) ;
				m_num = inner->mat.size() ;
				for( m = 0 ; m < m_num ; m++ ) {
					MQO_MATERIAL &mat = inner->mat.at(m) ;
					if( mat.vertex_p != NULL ) free(mat.vertex_p) ;
					if( mat.vertex_t != NULL ) free(mat.vertex_t) ;
					if( mat.VBO_id != 0 ) glDeleteBuffersARB(1,&mat.VBO_id) ;
				}
				delete inner ;
			}
			delete obj ;
		}
	}
public :
	//ǂݍ񂾃f[^̍ŏliAAjo
	// in frame  t[ԍ@ƑSt[̍ŏl
	// ߂l GLfloat[3]  0`Q@ꂼꂘAA
	const GLfloat *getMinPoint(int frame=-1) {
		if( frame < 0 ) {
			return m_seq.minPoint ;
		}
		if( frame < (int)m_seq.model.size() ) {
			return m_seq.model.at(frame)->minPoint ;
		}
		return NULL ;
	}
	//ǂݍ񂾃f[^̍őliAAjo
	// in frame  t[ԍ@ƑSt[̍ől
	// ߂l GLfloat[3]  0`Q@ꂼꂘAA
	const GLfloat *getMaxPoint(int frame=-1) {
		if( frame < 0 ) {
			return m_seq.maxPoint ;
		}
		if( frame < (int)m_seq.model.size() ) {
			return m_seq.model.at(frame)->maxPoint ;
		}
		return NULL ;
	}
	//ǂݍłt[o
	// ߂l@size_t t[
	size_t getFrameNum() {
		return m_seq.model.size() ;
	}
	//ǂݍł郂f̕`
	// in frame		`悷t[ԍiO`j
	// in alpha		xiOij`QTTj
	void render(int frame = 0,unsigned char alpha=0xff) {
		if( m_seq.model.size() <= (unsigned int)frame ) return ;
		MQO_OBJECT *sobj ;
		MQO_INNER_OBJECT	*obj;
		GLfloat				matenv[4] ;
		GLfloat				matenvGL_DIFFUSE[4] ;
		GLfloat				matenvGL_AMBIENT[4] ;
		GLfloat				matenvGL_SPECULAR[4] ;
		GLfloat				matenvGL_EMISSION[4] ;
		GLfloat				matenvGL_SHININESS ;
		GLboolean			isGL_ALPHA_TEST = GL_FALSE ;
		GLboolean			isGL_DEPTH_TEST = GL_FALSE ;
		GLint				bindGL_TEXTURE_2D = 0 ;
		GLboolean			isGL_TEXTURE_2D = GL_FALSE ;
		GLboolean			isGL_BLEND = GL_FALSE ;
		GLint				blendGL_SRC ;
		GLint				blendGL_DST ;
		GLint				enumGL_SHADE_MODEL ;
		//^ZR͒_̕т\ʂ݂ĉE
		GLint		intFrontFace ;

		int		 offset;
		double	dalpha;
		char	*base;
		size_t o,o_num ;
		size_t m,m_num ;
		//ύXp[^̕ۑ
		isGL_DEPTH_TEST = glIsEnabled(GL_DEPTH_TEST) ;
		isGL_ALPHA_TEST = glIsEnabled(GL_ALPHA_TEST) ;
		glGetIntegerv(GL_FRONT_FACE,&intFrontFace) ;
		glGetIntegerv(GL_SHADE_MODEL,&enumGL_SHADE_MODEL) ;
		isGL_TEXTURE_2D = glIsEnabled(GL_TEXTURE_2D) ;
		isGL_BLEND = glIsEnabled(GL_BLEND) ;
		glGetIntegerv(GL_TEXTURE_BINDING_2D,&bindGL_TEXTURE_2D) ;
		glGetIntegerv(GL_BLEND_SRC,&blendGL_SRC) ;
		glGetIntegerv(GL_BLEND_DST,&blendGL_DST) ;
		glGetMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,matenvGL_DIFFUSE) ;
		glGetMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,matenvGL_AMBIENT) ;
		glGetMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR,matenvGL_SPECULAR) ;
		glGetMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION,matenvGL_EMISSION) ;
		glGetMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS,&matenvGL_SHININESS) ;


		sobj = m_seq.model.at(frame) ;
		glPushMatrix();
			if( isGL_DEPTH_TEST == GL_FALSE ) {
				glEnable(GL_DEPTH_TEST);
			}
			if( isGL_ALPHA_TEST == GL_FALSE ) {
				glEnable(GL_ALPHA_TEST);
			}
			//^ZR͒_̕т\ʂ݂ĉE
			glFrontFace(GL_CW) ;
			dalpha = (double)alpha/(double)255;

			o_num = sobj->obj.size() ;
			for ( o=0; o<o_num; o++ ) {	// IuWFNg[v
				obj = sobj->obj.at(o) ;
				m_num = obj->mat.size() ;

	//			obj = &mqoobj[num].obj[o];
				if ( ! obj->isVisible ) continue;
				glShadeModel(((obj->isShadingFlat))?GL_FLAT:GL_SMOOTH) ;

				for ( m = 0; m < m_num; m++ ) {	//}eA[v
					MQO_MATERIAL &mat = obj->mat.at(m) ;

	//				mat = &obj->mat[m];
					if ( mat.datanum == 0 ) continue;

					if ( mat.isValidMaterialInfo ) {	// }eȀݒ
						// x̕ύXȂȂA̕ύX͗vȂc
						memcpy(matenv,mat.dif,sizeof(matenv)) ;
						matenv[3] *= dalpha ;
						glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, matenv);
						memcpy(matenv,mat.amb,sizeof(matenv)) ;
						matenv[3] *= dalpha ;
						glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, matenv);
						memcpy(matenv,mat.spc,sizeof(matenv)) ;
						matenv[3] *= dalpha ;
						glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, matenv);
						memcpy(matenv,mat.emi,sizeof(matenv)) ;
						matenv[3] *= dalpha ;
						glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION, matenv);
						glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS, mat.power);
					}

					if ( mat.isUseTexture) {	// eNX`ꍇ
						glEnableClientState( GL_VERTEX_ARRAY );
						glEnableClientState( GL_NORMAL_ARRAY );
						glEnableClientState( GL_TEXTURE_COORD_ARRAY );

						glEnable(GL_TEXTURE_2D);
						glEnable(GL_BLEND);
						glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

						glBindTexture(GL_TEXTURE_2D,mat.texture_id);

						if ( mat.VBO_id != 0 ) {	// _obt@gp
							base = (char *)NULL;	// AhXNULL擪
							glBindBufferARB( GL_ARRAY_BUFFER_ARB, mat.VBO_id ); // _obt@т
						}
						else {
							// _z̎́AAhX̂܂ܓ
							base = (char *)mat.vertex_t[0].point;
						}

						// _zݒ
						offset = (int)( (char *)mat.vertex_t[0].point - (char *)mat.vertex_t[0].point );
						glVertexPointer( 3, GL_FLOAT, sizeof(VERTEX_TEXUSE) , base + offset );

						// eNX`Wzݒ
						offset = (int)((char *)mat.vertex_t[0].uv-(char *)mat.vertex_t[0].point);
						glTexCoordPointer( 2, GL_FLOAT, sizeof(VERTEX_TEXUSE) , base + offset );

						// @zݒ
						offset = (int)((char *)mat.vertex_t[0].normal-(char *)mat.vertex_t[0].point);
						glNormalPointer( GL_FLOAT, sizeof(VERTEX_TEXUSE) , base+offset );

						// Fݒ
						glColor4f(mat.color[0],mat.color[1],mat.color[2],mat.color[3]);

						// `s
						glDrawArrays( GL_TRIANGLES, 0, mat.datanum );

						if ( mat.VBO_id != 0 ) {						// _obt@gp
							glBindBufferARB( GL_ARRAY_BUFFER_ARB, 0 );	// _obt@ftHg
						}

						glBindTexture(GL_TEXTURE_2D,0);

						glDisableClientState( GL_VERTEX_ARRAY );
						glDisableClientState( GL_NORMAL_ARRAY );
						glDisableClientState( GL_TEXTURE_COORD_ARRAY );
					}
					else {	// eNX`Ȃꍇ

						glEnableClientState( GL_VERTEX_ARRAY );
						glEnableClientState( GL_NORMAL_ARRAY );
					//	glEnableClientState( GL_COLOR_ARRAY );

						glDisable(GL_TEXTURE_2D);
						glEnable(GL_BLEND);
						glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

						if ( mat.VBO_id != 0 ) {	// _obt@gp
							base = (char *)NULL;
							glBindBufferARB( GL_ARRAY_BUFFER_ARB, mat.VBO_id );
						}
						else {
							base = (char *)mat.vertex_p[0].point;
						}

						// _zݒ
						offset = (int)((char *)mat.vertex_p[0].point-(char *)mat.vertex_p[0].point);
						glVertexPointer( 3, GL_FLOAT, sizeof(VERTEX_NOTEX) , base+offset );

						// @zݒ
						offset = (int)((char *)mat.vertex_p[0].normal-(char *)mat.vertex_p[0].point);
						glNormalPointer( GL_FLOAT, sizeof(VERTEX_NOTEX) , base+offset );

						// Fݒ
						glColor4f(mat.color[0],mat.color[1],mat.color[2],mat.color[3]);
					//	offset = (int)((char *)mat.vertex_p[0].color-(char *)mat.vertex_p[0].point);
					//	glColorPointer(4,GL_FLOAT,sizeof(VERTEX_NOTEX),base+offset);

						// `s
						glDrawArrays( GL_TRIANGLES, 0, mat.datanum );

						if ( mat.VBO_id != 0 ) {						// _obt@gp
							glBindBufferARB( GL_ARRAY_BUFFER_ARB, 0 );	// _obt@ftHg
						}

					//	glDisableClientState( GL_COLOR_ARRAY );
						glDisableClientState( GL_VERTEX_ARRAY );
						glDisableClientState( GL_NORMAL_ARRAY );

					}
				}
			}

		//ύXp[^̕A
			glShadeModel(enumGL_SHADE_MODEL) ;
			glBindTexture(GL_TEXTURE_2D,bindGL_TEXTURE_2D);
			glBlendFunc(blendGL_SRC,blendGL_DST);
			if( isGL_BLEND == GL_FALSE ) glDisable(GL_BLEND);
			if( isGL_TEXTURE_2D == GL_FALSE ) glDisable(GL_TEXTURE_2D);

			glFrontFace(intFrontFace) ;

			if( isGL_DEPTH_TEST == GL_FALSE ) {
				glDisable(GL_DEPTH_TEST);
			}
			if( isGL_ALPHA_TEST == GL_FALSE ) {
				glDisable(GL_ALPHA_TEST);
			}

			glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE,matenvGL_DIFFUSE) ;
			glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,matenvGL_AMBIENT) ;
			glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR,matenvGL_SPECULAR) ;
			glMaterialfv(GL_FRONT_AND_BACK, GL_EMISSION,matenvGL_EMISSION) ;
			glMaterialf(GL_FRONT_AND_BACK, GL_SHININESS,matenvGL_SHININESS) ;

		glPopMatrix();
	}
};

#include "cGLMetaseqParent.h"
#endif